// Make a very simple synthesizer based on the Atari Punk Console!
// Designed from scratch by UWTMC - https://uwtmc.com

// Bit Value
bool state = 0;

// The setup code runs once
void setup() {
  // Setup Input and Output Pins 
  pinMode(15,OUTPUT); // Connect the audio circuit to pin 15
  pinMode(A0,INPUT);  // Connect potentiometer one to pin A0
  pinMode(A1,INPUT);  // Connect potentiometer two to pin A1
}

// The main loop runs repeatedly over and over again...

// So this is close to right, but not exactly right, 
// but it makes it glitchy in a good way
void loop() {
  // Flip the bit representing the system state 
  state = !state;

  // Write to the digital output
  digitalWrite(15,state);

  // Calculate the time to wait and the duty cycle delay
  int halfPeriod = map(analogRead(A0),0,1023,800,25000);
  int dutyCycle = int(float(analogRead(A1))/1023.0*float(halfPeriod));

  // Wait some amount of time - adjust this for duty cycle depending
  // on the bit state (high or low)
  if(state){
    delayMicroseconds(halfPeriod+dutyCycle);      
  } else {
    delayMicroseconds(halfPeriod-dutyCycle);   
  }
}
